
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>


#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "screendef.h"
#include "sigdef.h"
#include "seldef.h"
#include "thrdef.h"
#include "rusage.h"
#include "txdef.h"
#include "options.h"
#include "conf.h"

#if BUFBARS == TRUE
#define RX_INDICATOR_MAXNUM 8
extern int rx_indicator_maxpos[RX_INDICATOR_MAXNUM];
extern int rx_indicator_minpos[RX_INDICATOR_MAXNUM];
void show_bufbar(int i, int k);
#endif

int baseb_output_block;
int baseb_min_block;

float iir3_gain[9]={6.0,
                    31.55634919,
                    188.6646578,
                    1274.138623,
                    9304.588559,
                    70996.86308,
                    554452.4788,
                    4382011.796, 
                    34842632.96};

float iir3_c0[9]={0.0,
                  0.1978251873,
                  0.4535459334,
                  0.6748018873,
                  0.8216600080,
                  0.9064815219,
                  0.9520967536,
                  0.9757549044,
                  0.9878031267};

float iir3_c1[9]={ -0.3333333333,
                   -0.9103690003,
                   -1.7151178300,
                   -2.2889939150,
                   -2.6262484669,
                   -2.8084292678,
                   -2.9030250284,
                   -2.9512131915,
                   -2.9755315293};

float iir3_c2[9]={ 0.0,
                   1.4590290622,
                   2.2191686183,
                   2.6079132760,
                   2.8037286680,
                   2.9018350649,
                   2.9509138462,
                   2.9754564614,
                   2.9877281729};

void blocking_rxout(void)
{
#if RUSAGE_OLD == TRUE
int local_workload_counter;
#endif
int initial_n, sleep_cnt;
int local_workload_reset;
char s[80];
char cc;
float sleep_time, short_sleep_time;
#if OSNUM == OS_FLAG_LINUX
clear_thread_times(THREAD_BLOCKING_RXOUT);
#endif
#if RUSAGE_OLD == TRUE
local_workload_counter=workload_counter;
#endif
local_workload_reset=workload_reset_flag;
sleep_time=2000000./snd[RXDA].interrupt_rate;
if(sleep_time < 1010)sleep_time=1010;
if(sleep_time > 100000)sleep_time=100000;
short_sleep_time=0.2*sleep_time;
if(short_sleep_time > 10000)short_sleep_time=10000;
if(short_sleep_time < 1010)short_sleep_time=1010;
if(rx_daout_bytes == 1)
  {
  cc=0x80;
  }
else
  {
  cc=0;
  }
lir_await_event(EVENT_BLOCKING_RXOUT);
daout_px=(daout_px-snd[RXDA].block_bytes+daout_size)&daout_bufmask;
memset(&daout[daout_px],cc,snd[RXDA].block_bytes);
// It may take a long time to return from the first write.
// 4Front OSS may require 0.1 second to set up the output
lir_rx_dawrite();
thread_status_flag[THREAD_BLOCKING_RXOUT]=THRFLAG_ACTIVE;
lir_sched_yield();
sleep_cnt=0;
initial_n=2;
while(!kill_all_flag && 
         thread_command_flag[THREAD_BLOCKING_RXOUT]==THRFLAG_ACTIVE)
  {
// *******************************************************
// *******************************************************
#if RUSAGE_OLD == TRUE
  if(local_workload_counter != workload_counter)
    {
    local_workload_counter=workload_counter;
    update_snd(RXDA);
    if(snd[RXDA].valid_bytes > snd[RXDA].block_bytes)
      {
      make_thread_times(THREAD_BLOCKING_RXOUT);
      update_snd(RXDA);
      }
    }
#endif
  if(local_workload_reset!=workload_reset_flag)
    {
    update_snd(RXDA);
    snd[RXDA].min_valid_frames=snd[RXDA].tot_frames;
    local_workload_reset=workload_reset_flag;
    }
  if( ((daout_pa-daout_px+daout_size)&daout_bufmask) > 
                                       initial_n*snd[RXDA].block_bytes)
    {
    initial_n=1;
    sleep_cnt=0;
    if(audio_dump_flag==0 && rx_audio_out != -1)
      {
      lir_rx_dawrite();
      if( ((daout_pa-daout_px+daout_size)&daout_bufmask) > 
                                                snd[RXDA].block_bytes)
        {
        lir_rx_dawrite();
        }
      }
    else
      {
      daout_px=(daout_px+snd[RXDA].block_bytes)&daout_bufmask;
      }
    }
  else
    {
    if(audio_dump_flag == 1 || rx_audio_out == -1)
      {
      lir_sleep(short_sleep_time);
      }
    else
      {
      update_snd(RXDA);
      if(snd[RXDA].valid_bytes > 4*snd[RXDA].block_bytes)
        {
        lir_sleep(sleep_time);
        goto loop_end;;   
        }
      if(snd[RXDA].valid_bytes < snd[RXDA].block_bytes/4)
        {
        if(count_rx_underrun_flag)
          {
          no_of_rx_underrun_errors++;
          sprintf(s,"RX%s%d",underrun_error_msg,no_of_rx_underrun_errors);
          wg_error(s,WGERR_RXOUT);
          }
// clear the buffer
        daout_px=(daout_px-snd[RXDA].block_bytes+daout_size)&daout_bufmask;
        memset(&daout[daout_px],cc,snd[RXDA].block_bytes);
        lir_rx_dawrite();
        lir_sleep(short_sleep_time);
        }
      else
        {
        sleep_cnt++;
        if(sleep_cnt > 2)lir_sleep(short_sleep_time);
        }
      }
    }
loop_end:;
  }
thread_status_flag[THREAD_BLOCKING_RXOUT]=THRFLAG_RETURNED;
while(!kill_all_flag &&
            thread_command_flag[THREAD_BLOCKING_RXOUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

void rx_output(void)
{
#if RUSAGE_OLD == TRUE
int local_workload_counter;
#endif
char delay_margin_flag;
char cc, blocking;
int dasync_time_interval, da_start_bytes;
int dasync_errors;
int daout_py;
int i, k;
char s[80];
double dt1;
int local_channels, local_bytes;
int local_workload_reset;
int speed_cnt;
float local_fft3_blocktime;
float t1, t2;
float sleep_time;
double total_time2;
#if OSNUM == OS_FLAG_LINUX
clear_thread_times(THREAD_RX_OUTPUT);
#endif
#if RUSAGE_OLD == TRUE
local_workload_counter=workload_counter;
#endif
blocking=TRUE;
#if PORTAUDIO_PRESENT == 1
if( (ui.use_alsa&PORTAUDIO_RX_OUT) != 0)
  {
  blocking=FALSE;
  }
#endif
thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_ACTIVE;
local_channels=rx_daout_channels;
local_bytes=rx_daout_bytes;
local_fft3_blocktime=fft3_blocktime;
daout_pa=0;
daout_px=0;
count_rx_underrun_flag=FALSE;
sys_func(THRFLAG_OPEN_RX_SNDOUT);
if(rx_audio_out == -1)blocking=FALSE;
if(kill_all_flag)goto da_output_error;
if(blocking && audio_dump_flag == 0 && rx_audio_out >= 0)
  {
  lir_rx_dawrite();
  daout_pa=0;
  daout_px=0;
  }
dasync_errors=0;
baseb_output_block=128;
da_start_bytes=-1;
thread_command_flag[THREAD_BLOCKING_RXOUT]=THRFLAG_NOT_ACTIVE;
if(blocking)
  {
  lir_init_event(EVENT_BLOCKING_RXOUT);
  lir_sched_yield();
  linrad_thread_create(THREAD_BLOCKING_RXOUT);
  }
while(!kill_all_flag && 
          thread_command_flag[THREAD_RX_OUTPUT]==THRFLAG_ACTIVE)
  {
  lir_sleep(3000);
  }
goto stop_output;
resume:;
if(blocking)
  {
  lir_init_event(EVENT_BLOCKING_RXOUT);
  lir_sched_yield();
  linrad_thread_create(THREAD_BLOCKING_RXOUT);
  }
if(lir_rxout_status != LIR_OK) 
  {
  wg_error("Output soundcard disabled",WGERR_SOUNDCARD);
  }
thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_ACTIVE;
count_rx_underrun_flag=FALSE;
lir_sched_yield();
sleep_time=1000000./snd[RXDA].interrupt_rate;
if(sleep_time < 1010)sleep_time=1010;
if(sleep_time > 100000)sleep_time=100000;
dasync_time_interval=7*fft3_size/timf3_sampling_speed;
if(dasync_time_interval < 7*fft1_size/timf1_sampling_speed)
                       dasync_time_interval = 7*fft1_size/timf1_sampling_speed;
if(genparm[SECOND_FFT_ENABLE]!=0)
  {
  if(dasync_time_interval < 7*fft2_size/timf1_sampling_speed)
                      dasync_time_interval = 7*fft2_size/timf1_sampling_speed;
  }
if(dasync_time_interval < 0.5)dasync_time_interval=0.5;
local_workload_reset=workload_reset_flag;
speed_cnt=snd[RXDA].interrupt_rate;
baseb_output_block=snd[RXDA].block_bytes/(2*da_resample_ratio);
if(baseb_output_block < 16)baseb_output_block=16;
baseb_min_block=1+1/da_resample_ratio;
if(baseb_min_block < baseb_output_block/16)
  {
  baseb_min_block=baseb_output_block/16;
  }
k=0;
dasync_time=current_time();
await_narrowband_processing:;
if(kill_all_flag) goto da_output_error;
if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)goto stop_output;
lir_sleep(2000);
make_timing_info();
if(kill_all_flag) goto da_output_error;
if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)goto stop_output;
t1=total_wttim-da_wttim-da_wait_time;
if(t1 < 0)
  {
  goto await_narrowband_processing;
  }
if(k == 0 && blocking)
  {
  lir_set_event(EVENT_BLOCKING_RXOUT);
  lir_sched_yield();
  make_timing_info();
  }
k++;
if(t1*baseband_sampling_speed > 3*baseb_output_block)
  {
  i=t1*baseband_sampling_speed;
  if(i > baseb_wts)i=baseb_wts;
  t1-=i/baseband_sampling_speed;
  baseb_py=(baseb_py+i+baseband_size)&baseband_mask;
  baseb_wts-=i;
  }
if(t1*baseband_sampling_speed > 3*baseb_output_block )//|| k<2)
  {
  if(recent_time-dasync_time > 2)
    {
    lirerr(1199);
    goto da_output_error;
    }
  goto await_narrowband_processing;
  }
if(blocking && thread_status_flag[THREAD_BLOCKING_RXOUT] != THRFLAG_ACTIVE)
  {
  goto await_narrowband_processing;
  }
baseb_fx=(baseb_py-2+baseband_size)&baseband_mask;
if(da_start_bytes == -1)
  {
  dasync_counter=0;
  dasync_sum=0;
  dasync_avg1=-1.5;
  dasync_avg2=-1.5;
  dasync_avg3=-1.5;
  dasync_time=current_time();
  dasync_avgtime=dasync_time;
  daspeed_time=dasync_time+1;
  }
daout_pa=0;
daout_px=0;
daout_py=0;
snd[RXDA].min_valid_frames=snd[RXDA].tot_frames;
min_daout_samps=baseband_size;
delay_margin_flag=TRUE;
while(!kill_all_flag &&
                   thread_command_flag[THREAD_RX_OUTPUT] == THRFLAG_ACTIVE)
  {
#if RUSAGE_OLD == TRUE
  if(local_workload_counter != workload_counter)
    {
    local_workload_counter=workload_counter;
    make_thread_times(THREAD_RX_OUTPUT);
    }
#endif
  if(audio_dump_flag==0)speed_cnt--;
  if(speed_cnt==0)
    {
    if(delay_margin_flag)
      {
      snd[RXDA].min_valid_frames=snd[RXDA].tot_frames;
      min_daout_samps=baseband_size;
      delay_margin_flag=FALSE;
      }
    if(local_workload_reset!=workload_reset_flag)
      {
      snd[RXDA].min_valid_frames=snd[RXDA].tot_frames;
      local_workload_reset=workload_reset_flag;
      }
    speed_cnt=snd[RXDA].interrupt_rate;
    total_time2=recent_time;
    if(total_time2-daspeed_time > 0)
      {
// Compute the D/A speed once every second.
      if(audio_dump_flag==0)
        {
        daspeed_time=total_time2+1;
        update_snd(RXDA);
        if(da_start_bytes == -1)
          {
          da_start_time=total_time2;
          da_block_counter=0;
          da_start_bytes=snd[RXDA].empty_bytes;
          snd[RXDA].min_valid_frames=snd[RXDA].tot_frames;
          count_rx_underrun_flag=TRUE;
          }
        else
          {
          measured_da_speed=(da_block_counter*snd[RXDA].block_bytes+
                                  snd[RXDA].empty_bytes-da_start_bytes)/
                          (snd[RXDA].framesize*(total_time2-da_start_time));
          }
        }
// Keep track of the error in the frequency ratio between input and output.
// Average the total processing delay and adjust resampling rate to
// keep it constant.
#define DASYNC_MAXCOUNT 15 //Number used to form average
      dt1=current_time();
      if(  diskread_flag == 0 &&
           new_baseb_flag == 0 &&
           dt1-dasync_avgtime > dasync_time_interval &&
           rx_audio_out != -1)
        {
        dasync_avgtime=dt1;
        make_timing_info();
        if(kill_all_flag) goto da_output_error;
        if(timinfo_flag != 0)
          {
          sprintf(s,"sync:%f ",total_wttim-dasync_avg3);
          lir_text(26,screen_last_line-8,s);
          }
        if(dasync_avg3 >= 0 && fabs(total_wttim-dasync_avg3)>0.5)
          {
          dasync_errors++;
          sprintf(s,"DA SYNC ERRORS %d",dasync_errors);
          wg_error(s,WGERR_DASYNC);
          baseb_reset_counter++;
          da_start_bytes=-1;
          dasync_counter=0; 
          }
        dasync_counter++;
        dasync_sum+=total_wttim;
        if(dasync_counter >= DASYNC_MAXCOUNT)
          {
          dasync_avg1=dasync_sum/dasync_counter;
          dasync_counter=0;
          dasync_sum=0;
          t2=dt1-dasync_time;
          dasync_time=dt1;
          if(dasync_avg2 > 0)
            {
// The drift between input and output after t2 seconds is
// the difference between the two averages.
// Convert to frequency ratio, but use half the error only
// to avoid oscillations.
// Correct for the deviation from the first average, but only 20%
// so we drift slowy towards it if we are off.
            t1= (t2+0.5*(dasync_avg2-dasync_avg1)+
                                   0.2*(dasync_avg3-dasync_avg1))/t2;
            new_da_resample_ratio=da_resample_ratio*t1;
            dasync_avg2=dasync_avg1;
            }
          else
            {
            if(dasync_avg3 <0)
              {
              dasync_avg3=dasync_avg1;
              }
            else
              {
              dasync_avg2=dasync_avg1;
              }
            }
          }
        }
      if(thread_command_flag[THREAD_RX_OUTPUT] != 
                                            THRFLAG_ACTIVE)goto stop_output;
      }
    }
// ***********************************************************
  lir_sched_yield();
  if( ((baseb_pa-baseb_py+baseband_size)&baseband_mask) > baseb_output_block )
    {
    if( ((daout_px-snd[RXDA].block_bytes-daout_pa+daout_size)&daout_bufmask) > (daout_size>>1) )
      {
      make_audio_signal();
      }
    else
      {
      if(audio_dump_flag==0)lir_sleep(sleep_time);
      }
    }
  else
    {
    lir_await_event(EVENT_BASEB);
    }
  if( (ui.network_flag&NET_RXOUT_BASEBRAW) != 0)
    {
#if NET_BASEBRAW_MODE == WFM_FM_FIRST_LOWPASS || \
    NET_BASEBRAW_MODE == WFM_FM_FIRST_LOWPASS_UPSAMP || \
    NET_BASEBRAW_MODE == WFM_STEREO_LOW || \
    NET_BASEBRAW_MODE == WFM_STEREO_HIGH    
    int *ntbuf;
    while(baseb_pn != baseb_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      ntbuf[0]=floor(1000000000.*baseb_fm_demod_low[baseb_pn]);
      baseb_pn=(baseb_pn+1)&baseband_mask;
      basebrawnet_pa=(basebrawnet_pa+4)&basebrawnet_mask;
      }
#endif
#if NET_BASEBRAW_MODE == WFM_FM_FULL_BANDWIDTH
    int *ntbuf;
    while(baseb_pn != baseb_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      ntbuf[0]=floor(300000000.*baseb_fm_demod[baseb_pn]);
      baseb_pn=(baseb_pn+1)&baseband_mask;
      basebrawnet_pa=(basebrawnet_pa+4)&basebrawnet_mask;
      }
#endif
#if NET_BASEBRAW_MODE == WFM_AM_FIRST_LOWPASS
    int *ntbuf;
    while(baseb_pn != baseb_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      ntbuf[0]=floor(0.2*sqrt(baseb_carrier_ampl[baseb_pn]));
      baseb_pn=(baseb_pn+1)&baseband_mask;
      basebrawnet_pa=(basebrawnet_pa+4)&basebrawnet_mask;
      }
#endif
#if NET_BASEBRAW_MODE == WFM_FM_FIRST_LOWPASS_RESAMP
    int *ntbuf;
    while(fm1_px != fm1_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      ntbuf[0]=floor(fm1_all[fm1_px]);
//        baseb_pn=(baseb_pn+1)&baseband_mask;
      fm1_px=(fm1_px+1)&fm1_mask;
      basebrawnet_pa=(basebrawnet_pa+4)&basebrawnet_mask;
      }
#endif
#if NET_BASEBRAW_MODE == BASEBAND_IQ
    int *ntbuf;
    while(baseb_pn != baseb_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      for(i=0; i<basebraw_ad_channels; i++)
        {
        ntbuf[i]=floor(0.05*baseb_raw[basebraw_ad_channels*baseb_pn+i]);
        }
      baseb_pn=(baseb_pn+1)&baseband_mask;
      basebrawnet_pa=(basebrawnet_pa+4*basebraw_ad_channels)&basebrawnet_mask;
      }
#endif
#if NET_BASEBRAW_MODE == WFM_SYNTHETIZED_FROM_FIRST_LOWPASS || \
    NET_BASEBRAW_MODE == WFM_SUBTRACT_FROM_FIRST_LOWPASS
    int *ntbuf;
    while(baseb_pn != baseb_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      for(i=0; i<basebraw_ad_channels; i++)
        {
        ntbuf[i]=floor(0.05*baseb_carrier[basebraw_ad_channels*baseb_pn+i]);
        }
      baseb_pn=(baseb_pn+1)&baseband_mask;
      basebrawnet_pa=(basebrawnet_pa+4*basebraw_ad_channels)&basebrawnet_mask;
      }
#endif
#if NET_BASEBRAW_MODE == WFM_AM_FULL_BANDWIDTH
    int *ntbuf;
    while(baseb_pn != baseb_pa && 
     ((basebrawnet_px-basebrawnet_pa+basebrawnet_mask)&basebrawnet_mask) >16)
      {
      ntbuf=(void*)&basebraw_netsend_buffer[basebrawnet_pa];
      ntbuf[0]=0.1*floor(sqrt(baseb_totpwr[baseb_pn]));
      baseb_pn=(baseb_pn+1)&baseband_mask;
      basebrawnet_pa=(basebrawnet_pa+4)&basebrawnet_mask;
      }
#endif
    }  
  if(kill_all_flag) goto da_output_error;
  if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)goto stop_output;
  if(audio_dump_flag == 1 || rx_audio_out == -1)
    {
    while( ((daout_pa-daout_px+daout_size)&daout_bufmask) > 
                                                 snd[RXDA].block_bytes)
      {
      daout_px=(daout_px+snd[RXDA].block_bytes)&daout_bufmask;
      if(kill_all_flag) goto da_output_error;
      if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)goto stop_output;
      }
    lir_sched_yield();
    if(kill_all_flag) goto da_output_error;
    if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)goto stop_output;
    }
  while(daout_px != daout_py)
    {
    if(wav_write_flag != 0)
      {
      if(fwrite(&daout[daout_py],snd[RXDA].block_bytes,1,wav_file)!=1)
                                                        wavsave_start_stop(0);
      wavfile_bytes+=snd[RXDA].block_bytes;
      }
    da_block_counter+=1;
    daout_py=(daout_py+snd[RXDA].block_bytes)&daout_bufmask;
    if(kill_all_flag) goto da_output_error;
    if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)goto stop_output;
    }
#if BUFBARS == TRUE
  if(baseband_handle != NULL && timinfo_flag!=0)
    {
    i=(daout_pa+2-daout_px+daout_bufmask+1)&daout_bufmask;
    i/=daout_indicator_block;
    show_bufbar(7,i);
    }
#endif
  }
stop_output:;                         
if(blocking)
  {
  lir_set_event(EVENT_BLOCKING_RXOUT);
  linrad_thread_stop_and_join(THREAD_BLOCKING_RXOUT);
  lir_close_event(EVENT_BLOCKING_RXOUT);
  }
//stop_output_2:;
daout_px=0;
daout_pa=0;
daout_py=0;
if(thread_command_flag[THREAD_RX_OUTPUT] == THRFLAG_IDLE)
  {
  if(rx_audio_out >= 0)lir_empty_da_device_buffer();
  thread_status_flag[THREAD_RX_OUTPUT] = THRFLAG_IDLE;
  lir_sleep(10000);
  while(thread_command_flag[THREAD_RX_OUTPUT] == THRFLAG_IDLE)
    {
    lir_sleep(5000);
    if(kill_all_flag) goto da_output_error;
    }
  daout_px=0;
  daout_pa=0;
  while(thread_command_flag[THREAD_RX_OUTPUT] == THRFLAG_SEMCLEAR)
    {
    thread_status_flag[THREAD_RX_OUTPUT] = THRFLAG_SEMCLEAR;
    lir_await_event(EVENT_RX_START_DA);
    if(kill_all_flag) goto da_output_error;
    }
  if(thread_command_flag[THREAD_RX_OUTPUT] == THRFLAG_ACTIVE)
    {
    if( rx_audio_out != -1 && (local_channels != rx_daout_channels ||
                               local_bytes != rx_daout_bytes ||
                               local_fft3_blocktime != fft3_blocktime))
      {
      sys_func(THRFLAG_CLOSE_RX_SNDOUT);
      lir_sched_yield();
      if(rx_daout_bytes == 1)
        {
        cc=0x80;
        }
      else
        {
        cc=0;
        }  
      daout_px=0;
      daout_pa=0;
      memset(&daout[daout_px],cc,snd[RXDA].block_bytes);
      sys_func(THRFLAG_OPEN_RX_SNDOUT);
      if(kill_all_flag || lir_rxout_status != LIR_OK) goto da_output_error;
      lir_empty_da_device_buffer();
      da_start_bytes=-1;
      local_channels=rx_daout_channels;
      local_bytes=rx_daout_bytes;
      local_fft3_blocktime=fft3_blocktime;
      }
    if(kill_all_flag) goto da_output_error;
    goto resume;
    }
  }
da_output_error:;
count_rx_underrun_flag=FALSE;
if(blocking && thread_command_flag[THREAD_BLOCKING_RXOUT] != THRFLAG_NOT_ACTIVE)
  {
  linrad_thread_stop_and_join(THREAD_BLOCKING_RXOUT);
  }
if(rx_audio_out >= 0)
  {
  if( (ui.use_alsa&(PORTAUDIO_RX_IN+PORTAUDIO_RX_OUT)) == 0)
    {
    while( rx_audio_out == tx_audio_in)lir_sleep(10000);
    }
  sys_func(THRFLAG_CLOSE_RX_SNDOUT);
  }
thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_NOT_ACTIVE &&
      thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_KILL)
  {
  lir_sleep(1000);
  }
}

void make_audio_signal(void)
{
int i,i1,i2,i3,i4,mm,nn;
float t1,t2,t3,t4,t5,t6,t7;
float a1, a2, b1, b2, u1, u2;
double dt1;
short int *intvar;
float r1,r2,r3,r4;
float rdiff, final_gain1, final_gain2;
float baseb_r1, baseb_r2;
int loop_counter;
i=1;
if(bg_filter_points > 5 && 2*bg_filter_points < bg_xpoints)
  {
  if(bg.squelch_level !=0)
    {
    if(recent_time-squelch_turnon_time > bg.squelch_time)
      {
      i=0;
      }
    }
  }
squelch_on=i;
// Resample the baseband signal so we get the correct sampling speed
// for the D/A converter.
// For each interval in baseb_out there is a non integer number of points
// in da_output.
dt1=1/sqrt(rx_daout_sin*rx_daout_sin+rx_daout_cos*rx_daout_cos);
rx_daout_sin*=dt1;
rx_daout_cos*=dt1;
final_gain1=final_gain2=0;
mm=snd[RXDA].framesize;
nn=2*baseb_channels;
baseb_r1=daout_pa/(mm*da_resample_ratio);
loop_counter=0;
resamp:;
baseb_r2=(daout_pa+mm)/(mm*da_resample_ratio);
i2=baseb_fx+baseb_r1+.5;
if(baseb_r2>baseb_r1)
  {
  i3=baseb_fx+baseb_r2+.5;
  }
else
  {
  i3=baseb_fx+baseb_r2+.5+daout_size/da_resample_ratio;
  }  
i2&=baseband_mask;
i3&=baseband_mask;
if(abs(i3-i2) > 1)
  {
  i2=baseb_fx+(baseb_r1+baseb_r2)/2;
  i3=i2+1;
  i2&=baseband_mask;
  i3&=baseband_mask;
  }
else
  {
  if(i3==i2)
    {
    i2=baseb_fx+baseb_r1;
    i2&=baseband_mask;
    if(i3==i2)
      {
      i3=i2+1;
      i3&=baseband_mask;
      }
    }
  }        
i4=(i3+1)&baseband_mask;
baseb_py=i4;
i1=(i2+baseband_mask)&baseband_mask;
baseb_wts=baseb_pa-baseb_r2-baseb_fx;
if(baseb_wts<0)baseb_wts+=baseband_size;
loop_counter++;
if(loop_counter > 2*baseb_output_block)lir_sched_yield();
if( ((daout_pa-daout_px+daout_size)&daout_bufmask) > (daout_size>>1) ||
     ((baseb_pa-baseb_py+baseband_size)&baseband_mask) < baseb_min_block)
  {
  return;  
  }
rdiff=baseb_r1+baseb_fx-i2;
if(rdiff > baseband_size/2)
  {
  rdiff-=baseband_size;
  }
// Use Lagrange's interpolation formula to fit a third degree
// polynomial to 4 points:
//  a1=-rdiff *   (rdiff-1)*(rdiff-2)*baseb_out[nn*i1]/6
//     +(rdiff+1)*(rdiff-1)*(rdiff-2)*baseb_out[nn*i2]/2
//     -(rdiff+1)* rdiff   *(rdiff-2)*baseb_out[nn*i3]/2
//     +(rdiff+1)* rdiff   *(rdiff-1)*baseb_out[nn*i4]/6; 
// Rewrite slightly to save a few multiplications - do not
// think the compiler is smart enough to do it for us.
t1=rdiff-1;
t2=rdiff-2;
t3=rdiff+1;
t4=t1*t2;
t5=t3*rdiff;
t6=rdiff*t4;
t4=t3*t4;
t7=t5*t2;
t5=t5*t1;
final_gain1=daout_gain;
final_gain2=daout_gain;
if(bg.agc_flag == 1)
  {
  if( daout_gain*baseb_agc_level[i2] > bg_agc_amplimit)
    {
    final_gain1=bg_agc_amplimit/baseb_agc_level[i2];
    final_gain2=final_gain1;
    }
  }    
if(bg.agc_flag == 2)
  {
  if( daout_gain*baseb_agc_level[2*i2] > bg_agc_amplimit)
    {
    final_gain1=bg_agc_amplimit/baseb_agc_level[2*i2];
    }
  if( daout_gain*baseb_agc_level[2*i2+1] > bg_agc_amplimit)
    {
    final_gain2=bg_agc_amplimit/baseb_agc_level[2*i2+1];
    }
  }
if(squelch_on == 0)
  {
  final_gain1=0;
  final_gain2=0;
  }
      
a1=final_gain1*(((t5*baseb_out[nn*i4  ]-t6*baseb_out[nn*i1  ])/3
                    +t4*baseb_out[nn*i2  ]-t7*baseb_out[nn*i3  ])/2);
a2=final_gain1*(((t5*baseb_out[nn*i4+1]-t6*baseb_out[nn*i1+1])/3
                    +t4*baseb_out[nn*i2+1]-t7*baseb_out[nn*i3+1])/2);

if(enable_resamp_iir5)
  {
  xva1[0]=xva1[1];
  xva1[1]=xva1[2];
  xva1[2]=xva1[3];
  xva1[3]=xva1[4]; 
  xva1[4]=xva1[5];
  xva1[5]=a1/iir_a.gain;
  yva1[0]=yva1[1];
  yva1[1]=yva1[2];
  yva1[2]=yva1[3];
  yva1[3]=yva1[4]; 
  yva1[4]=yva1[5];
  yva1[5]=xva1[0]+xva1[5]+5*(xva1[1]+xva1[4])+10*(xva1[2]+xva1[3])+
          iir_a.c0*yva1[0]+iir_a.c1*yva1[1]+iir_a.c2*yva1[2]+
          iir_a.c3 * yva1[3]+iir_a.c4*yva1[4];
  a1=yva1[5];
  xva2[0]=xva2[1];
  xva2[1]=xva2[2];
  xva2[2]=xva2[3];
  xva2[3]=xva2[4]; 
  xva2[4]=xva2[5];
  xva2[5]=a2/iir_a.gain;
  yva2[0]=yva2[1];
  yva2[1]=yva2[2];
  yva2[2]=yva2[3];
  yva2[3]=yva2[4];
  yva2[4]=yva2[5];
  yva2[5]=xva2[0]+xva2[5]+5*(xva2[1] + xva2[4])+10*(xva2[2]+xva2[3])+
          iir_a.c0*yva2[0]+iir_a.c1*yva2[1]+iir_a.c2*yva2[2]+
          iir_a.c3*yva2[3]+iir_a.c4*yva2[4];
  a2=yva2[5];
  }
old_out1=out1;
old_out2=out2;  
if(baseb_channels == 1)
  {
  if( (ui.network_flag&NET_RXOUT_BASEB) != 0)
    {
    short int *ntbuf;
    ntbuf=(void*)&baseb_netsend_buffer[basebnet_pa];
    if(rx_daout_bytes == 1)
      {
      ntbuf[0]=floor(256*a2);
      ntbuf[1]=floor(256*a1);
      }
    else
      {
      ntbuf[0]=floor(a2);
      ntbuf[1]=floor(a1);        
      }
    basebnet_pa=(basebnet_pa+4)&basebnet_mask;
    }
  if(rx_mode == MODE_FM)
    {
    out1=a1;
    out2=a2;
// ************************************
    t1=(out1-old_out1)/daout_upsamp;
    t2=old_out1;
    t3=(out2-old_out2)/daout_upsamp;
    t4=old_out2;
    for(i=0; i<daout_upsamp; i++)
      {
      xv1[0]=xv1[1]; 
      xv1[1]=xv1[2]; 
      xv1[2]=xv1[3]; 
      xv1[3]=t2/iir3_gain[daout_upsamp_n];
      yv1[0]=yv1[1]; 
      yv1[1]=yv1[2]; 
      yv1[2]=yv1[3]; 
      yv1[3]=xv1[0]+xv1[3]+3*(xv1[1]+xv1[2])+
              iir3_c0[daout_upsamp_n]*yv1[0]+
              iir3_c1[daout_upsamp_n]*yv1[1]+
              iir3_c2[daout_upsamp_n]*yv1[2];
      a1 = yv1[3];
      xv2[0]=xv2[1]; 
      xv2[1]=xv2[2]; 
      xv2[2]=xv2[3]; 
      xv2[3]=t4/iir3_gain[daout_upsamp_n];
      yv2[0]=yv2[1]; 
      yv2[1]=yv2[2]; 
      yv2[2]=yv2[3]; 
      yv2[3]=xv2[0]+xv2[3]+3*(xv2[1]+xv2[2])+
                    iir3_c0[daout_upsamp_n]*yv2[0]+
                    iir3_c1[daout_upsamp_n]*yv2[1]+
                    iir3_c2[daout_upsamp_n]*yv2[2];
      a2 = yv2[3];
      if(a1 < -bg_amplimit)a1=-bg_amplimit;
      if(a1 > bg_amplimit)a1=bg_amplimit;
      if(bg_maxamp < fabs(a1))bg_maxamp=fabs(a1); 
      if(a2 < -bg_amplimit)a2=-bg_amplimit;
      if(a2 > bg_amplimit)a2=bg_amplimit;
      if(bg_maxamp < fabs(a2))bg_maxamp=fabs(a2); 
      if(rx_daout_bytes == 1)
        {
        daout[daout_pa]=0x80+a1;
        if(rx_daout_channels == 2)daout[daout_pa+1]=0x80+a2;
        }
      else
        {  
        intvar=(void*)(&daout[daout_pa]);
        intvar[0]=a1;
        if(rx_daout_channels == 2)intvar[1]=a2;
        }
      daout_pa=(daout_pa+mm)&daout_bufmask;
      t2+=t1;
      t4+=t3;
      }
    }
  else
    {
    if(bg_expand != 2)
      {
      t1=sqrt(a1*a1+a2*a2);
      if(t1 > 0.5)
        {
        if(t1<bg_amplimit)t2=t1; else t2=bg_amplimit;
        if(bg_expand == 1)t2=bg_expand_a*(exp(bg_expand_b*t2)-1);
        t2/=t1;
        out1=t2*a1;
        out2=t2*a2;
        }
      else
        {
        out1=0;
        out2=0;
        }
      }
    else
      {
      out1=a1;
      out2=a2;
      }  
    t1=(out1-old_out1)/daout_upsamp;
    t2=old_out1;      
    t3=(out2-old_out2)/daout_upsamp;
    t4=old_out2;
    for(i=0; i<daout_upsamp; i++)
      {
      dt1=rx_daout_cos;
      rx_daout_cos=rx_daout_cos*rx_daout_phstep_cos+
                   rx_daout_sin*rx_daout_phstep_sin;
      rx_daout_sin=rx_daout_sin*rx_daout_phstep_cos-
                            dt1*rx_daout_phstep_sin;
      xv1[0]=xv1[1]; 
      xv1[1]=xv1[2]; 
      xv1[2]=xv1[3]; 
      xv1[3]=t2/iir3_gain[daout_upsamp_n];
      yv1[0]=yv1[1]; 
      yv1[1]=yv1[2]; 
      yv1[2]=yv1[3]; 
      yv1[3]=xv1[0]+xv1[3]+3*(xv1[1]+xv1[2])+
              iir3_c0[daout_upsamp_n]*yv1[0]+
              iir3_c1[daout_upsamp_n]*yv1[1]+
              iir3_c2[daout_upsamp_n]*yv1[2];
      a1 = yv1[3];
      xv2[0]=xv2[1]; 
      xv2[1]=xv2[2]; 
      xv2[2]=xv2[3]; 
      xv2[3]=t4/iir3_gain[daout_upsamp_n];
      yv2[0]=yv2[1]; 
      yv2[1]=yv2[2]; 
      yv2[2]=yv2[3]; 
      yv2[3]=xv2[0]+xv2[3]+3*(xv2[1]+xv2[2])+
                    iir3_c0[daout_upsamp_n]*yv2[0]+
                    iir3_c1[daout_upsamp_n]*yv2[1]+
                    iir3_c2[daout_upsamp_n]*yv2[2];
      a2 = yv2[3];
      u1= a1*rx_daout_cos+a2*rx_daout_sin;
      if(u1 > bg_amplimit)u1=bg_amplimit;
      if(u1 < -bg_amplimit)u1=-bg_amplimit;
      if(bg_maxamp < fabs(u1))bg_maxamp=fabs(u1); 
      if(da_ch2_sign == 0)
        {          
        u2=-a1*rx_daout_sin+a2*rx_daout_cos;
        if(u2 > bg_amplimit)u2=bg_amplimit;
        if(u2 < -bg_amplimit)u2=-bg_amplimit;
        if(bg_maxamp < fabs(u2))bg_maxamp=fabs(u2); 
        if(rx_daout_bytes == 1)
          {
          daout[daout_pa  ]=0x80+u1;
          daout[daout_pa+1]=0x80+u2;
          }
        else
          {  
          intvar=(void*)(&daout[daout_pa]);
          intvar[0]=u1;
          intvar[1]=u2;
          }
        }
      else
        {
        if(rx_daout_bytes == 1)
          {
          daout[daout_pa]=0x80+u1;
          if(rx_daout_channels == 2)daout[daout_pa+1]=0x80+u1*da_ch2_sign;
          }
        else
          {  
          intvar=(void*)(&daout[daout_pa]);
          intvar[0]=u1;
          if(rx_daout_channels == 2)intvar[1]=u1*da_ch2_sign;
          }
        }
      daout_pa=(daout_pa+mm)&daout_bufmask;
      t2+=t1;
      t4+=t3;
      }
    }
  }
else
  {
  old_out3=out3;
  old_out4=out4;
  b1=final_gain2*(((t5*baseb_out[nn*i4+2]-t6*baseb_out[nn*i1+2])/3
                    +t4*baseb_out[nn*i2+2]-t7*baseb_out[nn*i3+2])/2);
  b2=final_gain2*(((t5*baseb_out[nn*i4+3]-t6*baseb_out[nn*i1+3])/3
                    +t4*baseb_out[nn*i2+3]-t7*baseb_out[nn*i3+3])/2);

  if(enable_resamp_iir5)
    {
    xvb1[0]=xvb1[1];
    xvb1[1]=xvb1[2];
    xvb1[2]=xvb1[3];
    xvb1[3]=xvb1[4]; 
    xvb1[4]=xvb1[5];
    xvb1[5]=b1/iir_a.gain;
    yvb1[0]=yvb1[1];
    yvb1[1]=yvb1[2];
    yvb1[2]=yvb1[3];
    yvb1[3]=yvb1[4]; 
    yvb1[4]=yvb1[5];
    yvb1[5]=xvb1[0]+xvb1[5]+5*(xvb1[1]+xvb1[4])+10*(xvb1[2]+xvb1[3])+
            iir_a.c0*yvb1[0]+iir_a.c1*yvb1[1]+iir_a.c2*yvb1[2]+
            iir_a.c3 * yvb1[3]+iir_a.c4*yvb1[4];
    b1=yvb1[5];
    xvb2[0]=xvb2[1];
    xvb2[1]=xvb2[2];
    xvb2[2]=xvb2[3];
    xvb2[3]=xvb2[4];
    xvb2[4]=xvb2[5];
    xvb2[5]=b2/iir_a.gain;
    yvb2[0]=yvb2[1];
    yvb2[1]=yvb2[2];
    yvb2[2]=yvb2[3];
    yvb2[3]=yvb2[4];
    yvb2[4]=yvb2[5];
    yvb2[5]=xvb2[0]+xvb2[5]+5*(xvb2[1] + xvb2[4])+10*(xvb2[2]+xvb2[3])+
            iir_a.c0*yvb2[0]+iir_a.c1*yvb2[1]+iir_a.c2*yvb2[2]+
            iir_a.c3*yvb2[3]+iir_a.c4*yvb2[4];
    b2=yvb2[5];
    }
  if( (ui.network_flag&NET_RXOUT_BASEB) != 0)
    {
    short int *ntbuf;
    ntbuf=(void*)&baseb_netsend_buffer[basebnet_pa];
    if(rx_daout_bytes == 1)
      {
      ntbuf[0]=floor(256*a2);
      ntbuf[1]=floor(256*a1);
      ntbuf[2]=floor(256*b2);
      ntbuf[3]=floor(256*b1);
      }
    else
      {
      ntbuf[0]=floor(a2);
      ntbuf[1]=floor(a1);        
      ntbuf[2]=floor(b2);
      ntbuf[3]=floor(b1);        
      }
    basebnet_pa=(basebnet_pa+8)&basebnet_mask;
    }
  if(bg_expand != 2 && bg.agc_flag != 2)
    {
    t1=a1*a1+a2*a2;
    t2=b1*b1+b2*b2;
    if(t1 < t2)t1=t2;
    t1=sqrt(t1);
    if(t1 > 0.5)
      {
      if(t1<bg_amplimit)t2=t1; else t2=bg_amplimit;
      if(bg_expand == 1)t2=bg_expand_a*(exp(bg_expand_b*t2)-1);
      if(bg_maxamp < t2)bg_maxamp=t2; 
      t2/=t1;
      out1=t2*a1;
      out2=t2*a2;
      out3=t2*b1;
      out4=t2*b2;
      }
    else
      {
      out1=0;
      out2=0;
      out3=0;
      out4=0;
      }  
    }
  else
    {
    out1=a1;
    out2=a2;
    out3=b1;
    out4=b2;
    }
// ************************************
  t1=(out1-old_out1)/daout_upsamp;
  t2=old_out1;
  t3=(out2-old_out2)/daout_upsamp;
  t4=old_out2;
  r1=(out3-old_out3)/daout_upsamp;
  r2=old_out3;
  r3=(out4-old_out4)/daout_upsamp;
  r4=old_out4;
  for(i=0; i<daout_upsamp; i++)
    {
    dt1=rx_daout_cos;
    rx_daout_cos=rx_daout_cos*rx_daout_phstep_cos+
                 rx_daout_sin*rx_daout_phstep_sin;
    rx_daout_sin=rx_daout_sin*rx_daout_phstep_cos-
                        dt1*rx_daout_phstep_sin;
    xv1[0]=xv1[1]; 
    xv1[1]=xv1[2]; 
    xv1[2]=xv1[3]; 
    xv1[3]=t2/iir3_gain[daout_upsamp_n];
    yv1[0]=yv1[1]; 
    yv1[1]=yv1[2]; 
    yv1[2]=yv1[3]; 
    yv1[3]=xv1[0]+xv1[3]+3*(xv1[1]+xv1[2])+
                     iir3_c0[daout_upsamp_n]*yv1[0]+
                     iir3_c1[daout_upsamp_n]*yv1[1]+
                     iir3_c2[daout_upsamp_n]*yv1[2];
    a1 = yv1[3];
    xv2[0]=xv2[1]; 
    xv2[1]=xv2[2]; 
    xv2[2]=xv2[3]; 
    xv2[3]=t4/iir3_gain[daout_upsamp_n];
    yv2[0]=yv2[1]; 
    yv2[1]=yv2[2]; 
    yv2[2]=yv2[3]; 
    yv2[3]=xv2[0]+xv2[3]+3*(xv2[1]+xv2[2])+
                     iir3_c0[daout_upsamp_n]*yv2[0]+
                     iir3_c1[daout_upsamp_n]*yv2[1]+
                     iir3_c2[daout_upsamp_n]*yv2[2];
    a2 = yv2[3];
    xv3[0]=xv3[1]; 
    xv3[1]=xv3[2]; 
    xv3[2]=xv3[3]; 
    xv3[3]=r2/iir3_gain[daout_upsamp_n];
    yv3[0]=yv3[1]; 
    yv3[1]=yv3[2]; 
    yv3[2]=yv3[3]; 
    yv3[3]=xv3[0]+xv3[3]+3*(xv3[1]+xv3[2])+
                     iir3_c0[daout_upsamp_n]*yv3[0]+
                     iir3_c1[daout_upsamp_n]*yv3[1]+
                     iir3_c2[daout_upsamp_n]*yv3[2];
    b1 = yv3[3];
    xv4[0]=xv4[1]; 
    xv4[1]=xv4[2]; 
    xv4[2]=xv4[3]; 
    xv4[3]=r4/iir3_gain[daout_upsamp_n];
    yv4[0]=yv4[1]; 
    yv4[1]=yv4[2]; 
    yv4[2]=yv4[3]; 
    yv4[3]=xv4[0]+xv4[3]+3*(xv4[1]+xv4[2])+
                     iir3_c0[daout_upsamp_n]*yv4[0]+
                     iir3_c1[daout_upsamp_n]*yv4[1]+
                     iir3_c2[daout_upsamp_n]*yv4[2];
    b2 = yv4[3];
    u1= a1*rx_daout_cos+a2*rx_daout_sin;
    if(u1 > bg_amplimit)u1=bg_amplimit;
    if(u1 < -bg_amplimit)u1=-bg_amplimit;
  //  if(bg_maxamp < fabs(u1))bg_maxamp=fabs(u1); 
    u2= b1*rx_daout_cos+b2*rx_daout_sin;
    if(u2 > bg_amplimit)u2=bg_amplimit;
    if(u2 < -bg_amplimit)u2=-bg_amplimit;
 //   if(bg_maxamp < fabs(u2))bg_maxamp=fabs(u2); 
    if(rx_daout_bytes == 1)
      {
      daout[daout_pa]=0x80+u1;
      if(rx_daout_channels == 2)daout[daout_pa+1]=0x80+u2;
      }
    else
      {  
      intvar=(void*)(&daout[daout_pa]);
      intvar[0]=u1;
      if(rx_daout_channels == 2)intvar[1]=u2;
      }
if(rx_daout_channels==1)lirerr(213567);      
    daout_pa=(daout_pa+mm)&daout_bufmask;
    t2+=t1;
    t4+=t3;
    r2+=r1;
    r4+=r3;
    }
  }
baseb_r1=baseb_r2;

if(daout_pa > daout_bufmask)lirerr(994578);
if(daout_pa == 0)
  {
  baseb_fx+=baseb_r2;
  baseb_r1=0; 
  da_resample_ratio=new_da_resample_ratio;
  if(baseb_fx>baseband_size)baseb_fx-=baseband_size;
  if(use_bfo != 0)
    {
    t1=(2*PI_L*bg.bfo_freq)/genparm[DA_OUTPUT_SPEED];
    rx_daout_phstep_cos=cos(t1);
    rx_daout_phstep_sin=sin(t1);
    }
  }
if(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_ACTIVE)return;
goto resamp;  
}
